import { defineComponent, onMounted, reactive, ref } from 'vue';
import { useUserStore } from '/src/store/modules/users';
import styles from './index.module.less';
import { state } from '/src/state';
import { NModal, NSpin } from 'naive-ui';

export default defineComponent({
  name: 'notation-a',
  setup() {
    const show = ref(false);
    const previewModal = ref(false);
    const previewParams = ref({} as any);
    const userStore = useUserStore();
    const Authorization = userStore.getToken || '';
    console.log(Authorization);
    const data = reactive({
      src: `${
        /(192|localhost)/.test(location.origin)
          ? 'https://test.lexiaoya.cn'
          : // 'http://localhost:3050'
            location.origin
      }/notation/#/create?Authorization=${Authorization}`
      //   src: `http://localhost:3050/#/create?Authorization=${Authorization}`
    });
    const handleOpen = (e: MessageEvent) => {
      console.log(e.data, 'data');
      if (e.data.api === 'notation_open') {
        if (state.application) {
          show.value = true;
          previewModal.value = true;
          previewParams.value = {
            url: e.data.url
          };
        } else {
          window.open(e.data.url);
        }
      } else if (e.data.api === 'notation_exit') {
        previewModal.value = false;
        previewParams.value.url = '';
      }
    };
    onMounted(() => {
      window.addEventListener('message', handleOpen);
    });
    return () => (
      <div class={styles.wrap}>
        <iframe src={data.src}></iframe>

        <NModal
          v-model:show={previewModal.value}
          class={styles.previewWindow}
          showIcon={false}
          displayDirective="show">
          <NSpin show={show.value} style="--n-opacity-spinning: 1;">
            <iframe
              class={styles.previewIframe}
              onLoad={() => {
                show.value = false;
              }}
              frameborder="0"
              src={previewParams.value.url}></iframe>
          </NSpin>
        </NModal>
      </div>
    );
  }
});
